package ch.unil.bonita;

import java.io.Serializable;

public class Expense implements Serializable {
	private static final long serialVersionUID = 1L;
	private String title;
	private Float amount;
	private String currency;
	
	public String toString(){
		return "${title}: $amount $currency"
	}
			
	/**
	 * Returns an HTML representation of the expense
	 * the outermost div has the class isie_expense
	 * 
	 * @return HTML code
	 */
	public String toHtml(){
		def out = new StringWriter();
		def html = new groovy.xml.MarkupBuilder(out)
		html.div(['class': 'isie_expense']){
			div(this.toString())
		}
		return out.toString();
	}
	
	
	//manually write getter/setter for them to show up in bonita....

	public String getTitle() {
		return title;
	}

	public void setTitle(String title) {
		this.title = title;
	}

	public Float getAmount() {
		return amount;
	}

	public void setAmount(Float amount) {
		this.amount = amount;
	}

	public String getCurrency() {
		return currency;
	}

	public void setCurrency(String currency) {
		this.currency = currency;
	}
		
}
