package ch.unil.bonita;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class TravelPlan implements Serializable{
	private static final long serialVersionUID = 1L;
	private String user;
	private String title;
	private String city;
	private String countryCode;
	private String status;
	private Date startDate;
	private Date endDate;
	private Integer stars;
	private Hotel hotel;
	private List<Expense> expenses = new ArrayList<Expense>();
		
	public String toString(){
def out = """\
$title
${startDate?.format('MM/dd/yyyy')} - ${endDate?.format('MM/dd/yyyy')}
$city $countryCode
$status
$hotel
"""
	out += "Expenses:\n"
	for (Expense expense : expenses) {
			out += "$expense \n"
	}
	return out
}
	
	/**
	* Returns an HTML representation of the TravelPlan
	* the outermost div has the class isie_travelplan
	*
	* @return HTML code
	*/
	public String toHtml(){
		def out = new StringWriter();
		def html = new groovy.xml.MarkupBuilder(out)
		html.div(['class': 'isie_travelplan']){
			h3("$title")
			div("${startDate?.format('MM/dd/yyyy')} - ${endDate?.format('MM/dd/yyyy')}")
			div("$city $countryCode")
			div{
				span("Status:")
				div("$status")	
			}
			div{
				span("Hotel:")
				mkp.yieldUnescaped(hotel?.toHtml())
			}
			div("Expenses:")
			mkp.yieldUnescaped(expenses.collect{it?.toHtml()}.join())
		}
		return out.toString();
	}
	
	//manually write getter/setter for them to show up in bonita....
	
	public String getUser() {
		return user;
	}

	public void setUser(String user) {
		this.user = user;
	}

	public String getTitle() {
		return title;
	}

	public void setTitle(String title) {
		this.title = title;
	}

	public String getCity() {
		return city;
	}

	public void setCity(String city) {
		this.city = city;
	}

	public String getCountryCode() {
		return countryCode;
	}

	public void setCountryCode(String countryCode) {
		this.countryCode = countryCode;
	}

	public String getStatus() {
		return status;
	}

	public void setStatus(String status) {
		this.status = status;
	}

	public Date getStartDate() {
		return startDate;
	}

	public void setStartDate(Date startDate) {
		this.startDate = startDate;
	}

	public Date getEndDate() {
		return endDate;
	}

	public void setEndDate(Date endDate) {
		this.endDate = endDate;
	}

	public Integer getStars(){
		return stars;
	}
	
	public void setStarts(Integer starts){
		this.stars = starts;
	}
	
	public Hotel getHotel() {
		return hotel;
	}

	public void setHotel(Hotel hotel) {
		this.hotel = hotel;
	}

	public List<Expense> getExpenses() {
		return expenses;
	}

	public void setExpenses(List<Expense> expenses) {
		this.expenses = expenses;
	}
	
}
